﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;
using 简易静态服务器.Models;

namespace 简易静态服务器.Commands
{
   //实现接口
    public class MainCommand : ICommand
    {
        public event EventHandler CanExecuteChanged
        {
            add { CommandManager.RequerySuggested += value; }
            remove { CommandManager.RequerySuggested += value; }
        }      

        private Func<object,bool> CanExecuteEx;
      
        private Action Exctue;
           
        public MainCommand(Action  Exectue,Func<object,bool>CanExcetue)
        {
            Exctue = Exectue ?? throw new ArgumentNullException("erro");
            CanExecuteEx = CanExcetue;
        }
       
        public bool CanExecute(object parameter)
        {
            var temp = CanExecuteEx(parameter);

            return temp;
        }

        public void Execute(object parameter)
        {
           
            Exctue?.Invoke();
        }
    }
}
